Target Conversion in JavaScript

Using ApexCharts with JavaScript

This Target Conversion example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
var options = {
  series: [288000, 84000, 21000, 17000],
  chart: {
    type: 'unit',
    height: 470,
    animations: {
      enabled: true,
      speed: 900,
    },
  },
  labels: ['Reached', 'Engaged', 'Qualified', 'Converted'],
  // A funnel is ordered and its rings are already separated by geometry, so here a
  // ramp earns its keep - the eye reads "narrowing toward the bullseye". It turns
  // hue as it darkens and takes bigger steps than a pure tint scale would, so
  // neighbouring rings still separate at this dot size.
  colors: ['#7FC0DE', '#219EBC', '#0E7C7B', '#023047'],
  plotOptions: {
    unit: {
      layout: 'custom',
      // One of the shapes in apexcharts/unit-shapes.
      positions: 'target',
      transition: 'flow',
      unitValue: 500,
      clusterLabels: {
        // No outer labels here: those alternate down the two margins, which suits
        // a shape whose bands stack vertically. Concentric rings would need the
        // inner labels' leader lines to cross the outer rings, so the legend does
        // a cleaner job for a target.
        show: false,
      },
    },
  },
  legend: {
    position: 'bottom',
  },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Target Conversion in Vue

Using ApexCharts with Vue

This Target Conversion example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div class="wrap">
      <h1>410,000 reached, 17,000 converted</h1>
      <p>
        A funnel as a target. The layout lays its dots on concentric rings,
        spaced one dot apart in both directions and handed out from the outside
        in, so the stages fall into bands and the last one lands in the
        bullseye. The rings are positions only: the colours come from the
        series, as they do in every other unit layout.
      </p>

      <div class="chart-wrap">
        <div id="chart">
          <apexchart
            type="unit"
            height="470"
            :options="chartOptions"
            :series="series"
          ></apexchart>
        </div>
      </div>

      <p class="note">1 dot = 500 people</p>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

// This demo also loads: https://cdn.jsdelivr.net/npm/apexcharts/dist/unit-shapes.js

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [288000, 84000, 21000, 17000],
      chartOptions: {
        chart: {
          type: 'unit',
          height: 470,
          animations: {
            enabled: true,
            speed: 900,
          },
        },
        labels: ['Reached', 'Engaged', 'Qualified', 'Converted'],
        // A funnel is ordered and its rings are already separated by geometry, so here a
        // ramp earns its keep - the eye reads "narrowing toward the bullseye". It turns
        // hue as it darkens and takes bigger steps than a pure tint scale would, so
        // neighbouring rings still separate at this dot size.
        colors: ['#7FC0DE', '#219EBC', '#0E7C7B', '#023047'],
        plotOptions: {
          unit: {
            layout: 'custom',
            // One of the shapes in apexcharts/unit-shapes.
            positions: 'target',
            transition: 'flow',
            unitValue: 500,
            clusterLabels: {
              // No outer labels here: those alternate down the two margins, which suits
              // a shape whose bands stack vertically. Concentric rings would need the
              // inner labels' leader lines to cross the outer rings, so the legend does
              // a cleaner job for a target.
              show: false,
            },
          },
        },
        legend: {
          position: 'bottom',
        },
      },
    }
  },
}
</script>

<style>
body {
  font-family:
    -apple-system, BlinkMacSystemFont, 'Segoe UI', Roboto, sans-serif;
  background: #fafbfc;
  color: #2c3e50;
  margin: 0;
  padding: 32px 16px;
}
.wrap {
  max-width: 720px;
  margin: 0 auto;
}
h1 {
  font-size: 22px;
  margin: 0 0 8px;
}
p {
  color: #5b6b78;
  line-height: 1.5;
  margin: 0 0 24px;
}
.chart-wrap {
  background: #fff;
  border-radius: 8px;
  padding: 16px;
  box-shadow: 0 2px 10px rgba(0, 0, 0, 0.04);
}
.note {
  color: #8592a0;
  font-size: 12px;
  text-align: center;
  margin: 16px 0 0;
}
</style>

Target Conversion in Angular

Using ApexCharts with Angular

This Target Conversion example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  public chartOptions: Partial<ChartOptions> = {
          series: [288000, 84000, 21000, 17000],
          chart: {
            type: 'unit',
            height: 470,
            animations: {
              enabled: true,
              speed: 900,
            },
          },
          labels: ['Reached', 'Engaged', 'Qualified', 'Converted'],
          // A funnel is ordered and its rings are already separated by geometry, so here a
          // ramp earns its keep - the eye reads "narrowing toward the bullseye". It turns
          // hue as it darkens and takes bigger steps than a pure tint scale would, so
          // neighbouring rings still separate at this dot size.
          colors: ['#7FC0DE', '#219EBC', '#0E7C7B', '#023047'],
          plotOptions: {
            unit: {
              layout: 'custom',
              // One of the shapes in apexcharts/unit-shapes.
              positions: 'target',
              transition: 'flow',
              unitValue: 500,
              clusterLabels: {
                // No outer labels here: those alternate down the two margins, which suits
                // a shape whose bands stack vertically. Concentric rings would need the
                // inner labels' leader lines to cross the outer rings, so the legend does
                // a cleaner job for a target.
                show: false,
              },
            },
          },
          legend: {
            position: 'bottom',
          },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Target Conversion in React

Using ApexCharts with React

This Target Conversion example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

// This demo also loads: https://cdn.jsdelivr.net/npm/apexcharts/dist/unit-shapes.js

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [288000, 84000, 21000, 17000],
    options: {
      chart: {
        type: 'unit',
        height: 470,
        animations: {
          enabled: true,
          speed: 900,
        },
      },
      labels: ['Reached', 'Engaged', 'Qualified', 'Converted'],
      // A funnel is ordered and its rings are already separated by geometry, so here a
      // ramp earns its keep - the eye reads "narrowing toward the bullseye". It turns
      // hue as it darkens and takes bigger steps than a pure tint scale would, so
      // neighbouring rings still separate at this dot size.
      colors: ['#7FC0DE', '#219EBC', '#0E7C7B', '#023047'],
      plotOptions: {
        unit: {
          layout: 'custom',
          // One of the shapes in apexcharts/unit-shapes.
          positions: 'target',
          transition: 'flow',
          unitValue: 500,
          clusterLabels: {
            // No outer labels here: those alternate down the two margins, which suits
            // a shape whose bands stack vertically. Concentric rings would need the
            // inner labels' leader lines to cross the outer rings, so the legend does
            // a cleaner job for a target.
            show: false,
          },
        },
      },
      legend: {
        position: 'bottom',
      },
    },
  })

  return (
    <div>
      <div className="wrap">
        <h1>410,000 reached, 17,000 converted</h1>
        <p>
          A funnel as a target. The layout lays its dots on concentric rings,
          spaced one dot apart in both directions and handed out from the
          outside in, so the stages fall into bands and the last one lands in
          the bullseye. The rings are positions only: the colours come from the
          series, as they do in every other unit layout.
        </p>

        <div className="chart-wrap">
          <div id="chart">
            <ReactApexChart
              options={state.options}
              series={state.series}
              type="unit"
              height={470}
            />
          </div>
        </div>

        <p className="note">1 dot = 500 people</p>
      </div>
    </div>
  )
}

export default ApexChart